class Carrito{

    comprarProducto(e){
        e.preventDefault();

        if(e.target.classList.contains('agregar-carrito')){
            const producto = e.target.parentElement.parentElement;
            this.leerDatosProducto(producto);
            this.carritoItems();
        }
    }

    leerDatosProducto(producto){

        const infoProducto = {
            imagen: producto.querySelector('img').src,
            titulo: producto.querySelector('p').textContent,
            precio: producto.querySelector('.pos-r p').textContent,
            id: producto.querySelector('.pos-r a').getAttribute('data-id'),
            comercio_id: producto.querySelector('p').getAttribute('data-id'),
            cantidad: 1,
        }
        let productosLS;

        productosLS = this.obtenerProductosLocalStorage();
        productosLS.forEach(function(productoLS){
            if(productoLS.id === infoProducto.id){
                productosLS = productoLS.id;
            }
        });

        if(productosLS === infoProducto.id){
            Swal.fire({
                type: 'info',
                title: 'Ooops..',
                text: 'El producto ya fue agregado',
                timer: 1500,
                showConfirmButton: false,
            })
        }else{
            this.insertarCarrito(infoProducto);
        }
    }

    insertarCarrito(producto){
        const row = document.createElement('tr');
        row.innerHTML =`
            <td>
                <img src="${producto.imagen}" width=100 />
            </td>
            <td>${producto.titulo}</td>
            <td>${producto.precio}</td>
            <td>
                <a href="#" class="borrar-producto pull-right" data-id="${producto.id}">&#10006;</a>
            </td>
        `;
        listaProductos.appendChild(row);
        this.guardarProductosLocalStorage(producto);
        this.calcularTotal();
    }

    eliminarProducto(e){
        e.preventDefault();
        let producto, productoID;
        if(e.target.classList.contains('borrar-producto')){
            e.target.parentElement.parentElement.remove();
            producto = e.target.parentElement.parentElement;
            productoID = producto.querySelector('a').getAttribute('data-id');
        }
        this.eliminarProductoLocalStorage(productoID);
        this.calcularTotal();
        this.carritoItems();
    }

    vaciarCarrito(e){
        e.preventDefault();
        while(listaProductos.firstChild){
            listaProductos.removeChild(listaProductos.firstChild);
        }
        this.vaciarLocalStorage();

        return false;
    }

    guardarProductosLocalStorage(producto){
        let productos;
        productos = this.obtenerProductosLocalStorage();
        productos.push(producto);
        localStorage.setItem('productos', JSON.stringify(productos));

    }

    obtenerProductosLocalStorage(){
        let productoLS;

        if(localStorage.getItem('productos') === null){
            productoLS = [];
        }else{
            productoLS = JSON.parse(localStorage.getItem('productos'));
        }
        return productoLS;
    }

    eliminarProductoLocalStorage(productoID){
        let productosLS;
        productosLS = this.obtenerProductosLocalStorage();
        productosLS.forEach(function(productoLS, index) {
            if(productoLS.id === productoID){
                productosLS.splice(index, 1);
            }
        });

        localStorage.setItem('productos', JSON.stringify(productosLS));
    }

    leerLocalStorage(){
        let productosLS;
        productosLS = this.obtenerProductosLocalStorage();
        productosLS.forEach(function(producto){
            const row = document.createElement('tr');
            row.innerHTML =`
                <td>
                    <img src="${producto.imagen}" width=100 />
                </td>
                <td>${producto.titulo}</td>
                <td>${producto.cantidad}</td>
                <td>${producto.precio}</td>
                <td>
                    <a href="#" class="borrar-producto pull-right" data-id="${producto.id}">&#10006;</a>
                </td>
            `;
            listaProductos.appendChild(row);
        });
    }

    carritoItems(){
        let productosLS = JSON.parse(localStorage.getItem('productos'));
        document.getElementById('cart-count').innerHTML = productosLS.length;
    }

    vaciarLocalStorage(){
        localStorage.clear();
    }

    procesarPedido(e){
        e.preventDefault();
        if(this.obtenerProductosLocalStorage().length === 0){
            Swal.fire({
                type: 'error',
                title: 'Ooops..',
                text: 'El carrito de compras esta vacio, agrega un producto.',
                timer: 2000,
                showConfirmButton: false,
            })
        }else{
            location.href = "carrito";
        }
    }

    leerLocalStorageCompra(){
        let productosLS;
        productosLS = this.obtenerProductosLocalStorage();
        //console.log(productosLS);
        productosLS.forEach(function(producto){
            const row = document.createElement('tr');
            row.innerHTML =`
                <td>
                    <img src="${producto.imagen}" width=100 />
                </td>
                <td>${producto.titulo}</td>
                <td>${producto.precio}</td>
                <td>
                    <input type="number" class="form-control cantidad" min="1" max="100" value=${producto.cantidad} />
                </td>
                <td id="subtotales">${producto.precio * producto.cantidad}</td>
                <td>
                    <a href="#" class="borrar-producto pull-right" style="font-size:20px;" data-id="${producto.id}">&#10006;</a>
                </td>
            `;
            listaCompra.appendChild(row);
        });
    }

    calcularTotal(){
        let productosLS;
        let total = 0, igv = 0, subtotal = 0;
        productosLS = this.obtenerProductosLocalStorage();
        for(let i = 0; i < productosLS.length; i++){
            let element = Number(productosLS[i].precio * productosLS[i].cantidad);
            total = total + element;
            
        }
        
        igv = parseFloat(total * 0.18).toFixed(2);
        subtotal = parseFloat(total-igv).toFixed(2);

        document.getElementById('subtotal').innerHTML = "S/. " + subtotal;
        document.getElementById('igv').innerHTML = "S/. " + igv;
        document.getElementById('total').textContent = total.toFixed(2);
    }

    obtenerEvento(e) {
        e.preventDefault();
        let id, cantidad, producto, productosLS;
        if (e.target.classList.contains('cantidad')) {
            producto = e.target.parentElement.parentElement;
            id = producto.querySelector('a').getAttribute('data-id');
            cantidad = producto.querySelector('input').value;
            let actualizarMontos = document.querySelectorAll('#subtotales');
            productosLS = this.obtenerProductosLocalStorage();
            productosLS.forEach(function (productoLS, index) {
                if (productoLS.id === id) {
                    productoLS.cantidad = cantidad;                    
                    actualizarMontos[index].innerHTML = Number(cantidad * productosLS[index].precio);
                }    
            });
            localStorage.setItem('productos', JSON.stringify(productosLS));
            
        }
        else {
            console.log("click afuera");
        }
    }

}